import os

IPXE_GIT_URI = 'git://git.ipxe.org/ipxe.git'
IPXE_ROM_SUFFIXES = ('rom', 'mrom')
IPXE_ROM_FIRMWARES = ('rtl8139',
                      '8086100e',
                      '80861209',
                      '10500940',
                      '10222000',
                      '10ec8139',
                      '1af41000',  # firmware used by virtIO
                      '8086100f',
                      '808610d3',
                      '15ad07b0')
_cur_dir = os.path.dirname(os.path.abspath(os.path.expanduser(__file__)))
IPXE_SAMPLE_CONFIG = os.path.abspath(os.path.join(_cur_dir, 'example.config.xml'))
IPXE_DEFAULT_CFG = '~/.config/bootbox/ipxe_build.xml'
if os.geteuid() == 0:
    IPXE_DEFAULT_LOGFILE = '/var/log/bootbox/ipxe.log'
else:
    IPXE_DEFAULT_LOGFILE = '~/.cache/bootbox/ipxe.log'
DEF_PORTS = {'git': 9418,
             'http': 80,
             'https': 443}
IPXE_CATEGORIES = ('default',
                   'efi',
                   'iso',
                   'legacy',
                   'roms')
